﻿--[[
	News info plguin
]]--


--------------------------------------
-- Create plugin

local RW = LibStub("AceAddon-3.0"):GetAddon("Raid Watch")
local plugin = RW:Plugin("News")
if not plugin then return end

--------------------------------------
-- Locals
local L = LibStub("AceLocale-3.0"):GetLocale("RW2-Plugin-Base")
local UIF
local AceGUI
local news = {}

--------------------------------------
-- Init

function plugin:OnRegister()
	self.db = RW.db:RegisterNamespace("News", {profile={}})
end

function plugin:PluginEnable()
	UIF = LibStub("LibGUIFactory-1.0"):GetFactory("RW")
	AceGUI = LibStub("AceGUI-3.0")
end

function plugin:PluginDisable()
end

--------------------------------------
-- Options
function plugin:GetOptions()
	return 98, L.NEWS, self.GetGUI
end

function plugin:GetGUI()
	self = self or plugin
	
	local group, label, color, check
	
	group = AceGUI:Create("ScrollFrame")
	group:SetLayout("Flow")
	
	label = UIF:MainTitleLabel(L.NEWS)
	group:AddChild(label)
	
	local igroup = UIF:InlineGroup("")
	group:AddChild(igroup)	
	
	for title, data in pairs(news) do
		local newsGroup = UIF:InlineGroup2(title)
		igroup:AddChild(newsGroup)
		
		self:GetNewsAsGUI(newsGroup, data, "")
	end
	
	return group
end

function plugin:GetNewsAsGUI(group, data, level)
	for i, subData in pairs(data) do
		if type(subData) == "table" then
			group:AddChild(UIF:NormalText(level.."* "..i))
			plugin:GetNewsAsGUI(group, subData, level.."       ")
		else
			group:AddChild(UIF:NormalText(level.."- "..subData))
		end
	end
end

news["1.26 Release 2010-05-04"] = {
	["Core"] = {
		"Bossmods wont start instantly after defeating a boss, it will need a minimum of 5s in between kill/wipe and a restart. This could happen at for example saurfang that did the finish yell before he actually died.",
		"Custom timers can now be started via /rwtimer(g) <time> * <message> * [<id>], fields are separated by the \"*\", the <id> is optional and can be used if you want to update a timer you allready sent, if its not used then a new timer will be started each time. The format of the <time> tag is in seconds or colon separated, \"55\" will give a 55s timer, \"10:24\" will give a 10min 24s timer. /rwtimer is a local timer /rwtimerg is a global that is sent to all that uses Raid Watch in your current Party/Raid.",
		"A new option is added to the Plugins page under the \"Toggle config mode\" button, \"Show Health frame for all bosses\". This will turn on health frames for almost all bosses, only for encounters like Faction Champions it wont be used. There is also an option to turn them off for individual bosses in the boss options.",
		"Raid Watch will now throw a warning when the combatlog stop working. This will happen if in combat with any boss and there is no combatlog event for more then 10s",
		"Raid Watch will now throw a warning when the combatlog stop working. This will happen if in combat with any boss and there is no combatlog event for more then 10s. It will try to fix it via CombatLogClearEntries(), but if the message keep repeating every 60s you will need to restart the client.",
	},
	["Plugins"] = {
		["Timers"] = {
			"Timers can now be set to empty out or full up in the options.",
			"The function to report remaining time is back. Shift + left klick to announce the timer to Party/Raid.",
		}
	},
	["ICC"] = {
		["Lady Deathwhisper"] = {
			"Added target message for Curse of Torpor, default turned off.",
		},
		["Deathbringer Saurfang"] = {
			"AVR-Circle now only shows around yourself and not for every player in the raid.",
			"Added target message and duration for Bloiling Blood, both turned off by default.",
		},
		["The Lich King"] = {
			"Added cooldown timer for Summon Drudge Ghouls, default turned off (Usefull for LK tank).",
			"Added timer that show when the next person will be afflicted by Raging Spirit debuff.",
			"Improved the Val'kyre grab detectin. It will now retport players instantly when they are grabbed instead of waiting untill all are grabbed.",
			"Added a personal warning when you get picked up by a Val'kyr.",
			"Improved the Infest timer, it will now show the time untill the first infest after phase transition.",
			"Small adjustments to Defile, Val'kyr and infest cooldown timers.",
		},
	},
}